/* d_subckt.h		-*- C++ -*-
 *$Header: /al/acs/src/RCS/d_subckt.h,v 8.1 95/04/23 18:18:52 al Exp $
 * data structures for subcircuits
 */
#define D_SUBCKT_H

#ifndef E_SUBCKT_H
#include "e_subckt.h"
#endif

#define UNUSED 0
#define USED -3
#define NODESPERSUBCKT 1000
#define PORTSPERSUBCKT 100

#define sDEFAULT_modelname	""

class DEV_SUBCKT : public BASE_SUBCKT {
public:
	DEV_SUBCKT();
	DEV_SUBCKT(const DEV_SUBCKT&);
	CARD*	clone()const{return new DEV_SUBCKT(*this);}
	void	parse(CS&);
 	void	print(int,int)const;
	double	probe_tr_num(const char*)const;
	void	expand();
};

struct subckt {
   generic_t	*x;
   size_t	ssize;
   const generic_t *m;
   char		modelname[LABELEN+1];
   node_t	n[PORTSPERSUBCKT+1];
};

class MODEL_SUBCKT : public COMPONENT {
public:
	MODEL_SUBCKT(const char *name = "");
	MODEL_SUBCKT(const MODEL_SUBCKT& p){assert(!"copy-model??");}
	CARD*	clone()const{return new MODEL_SUBCKT(*this);}
	void	parse(CS&);
 	void	print(int,int)const;
};

struct smod {
   generic_t	*x;
   size_t	ssize;
   const generic_t *m;
   char		modelname[LABELEN+1];
   node_t	n[PORTSPERSUBCKT+1];
};
