/* e_node.h		-*- C++ -*-
 *$Header: /al/acs/src/RCS/e_node.h,v 8.2 95/04/27 13:52:25 al Exp $
 * circuit node class
 */
#define E_NODE_H

#ifndef E_BASE_H
#include "e_base.h"
#endif

struct lmod;
class xprobe_t;
 
#define	qBAD	 (0)
#define qGOOD	 (OPT::transits)
class MODEL_LOGIC;

class NODE : public CKT_BASE {
public:
    int		number;		/* internal node number (redundant) */
    const MODEL_LOGIC *family;	/* logic family */
    int 	diter;		/* iteration of last update - digital */
    int 	aiter;		/* iteration of last update - analog */
    double	finaltime;	/* time logic transition attains final state */
    double	lastchange;	/* time of last change */
    double	dt;		/* time diff, for conversion */
    unsigned	lv0:1,		/* old, current value */
		lv1:1,		/* new, future value */
		ls0:1,		/* old, current strength */
		ls1:1,		/* new, future strength */

		nodemode:2,	/* simulation mode */
		quality:4,	/* quality of digital mode */

		needslu:1;	/* changed.  LU decomposition needed */
    int		needsanalog;	/* analog info requested (count/flag) */
    const char*	failuremode;
public:
		 NODE();
	char*	 printlabel(int where=0)const;
	double	 probe_tr_num(const char*)const;
	xprobe_t probe_ac_ext(const char*)const;
	double	 logicval()const;
};
#define nodestat NODE

struct nodestuff {
    double	*i;		/* dc-tran current (i) vector		*/
    double	*v0;		/* dc-tran voltage, new			*/
    double	*vt1;		/* dc-tran voltage, 1 time ago		*/
    double	*fw;		/* dc-tran fwd sub intermediate values	*/
    double	*vdc;		/* saved dc voltages			*/
    complex	*ac;		/* ac right side			*/
    int		*nm;		/* node map (external to internal)	*/
};
