/* s__solve.cc
 *$Header: /al/acs/src/RCS/s__solve.cc,v 8.1 95/04/23 18:20:29 al Exp $
 * solve one step or a transient analysis
 */
#include "ecah.h"
#include "m_matrix.h"
#include "error.h"
#include "io.h"
#include "e_node.h"
#include "u_option.h"
#include "u_status.h"
#include "e_card.h"
#include "s__.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//	int	SIM::solve(int,int);
static	void	advance_time(void);
static	void	clear_arrays(void);
/*--------------------------------------------------------------------------*/
extern 	     struct nodestuff ns;
extern BSMATRIXdouble aa;
/*--------------------------------------------------------------------------*/
int SIM::solve(int itl, int trace)	/* solve one time step		    */
{
  int converged = NO;
  
  STATUS::iter[iSTEP] = 0;
  advance_time();
  
  inc_mode = (inc_mode == NO) ? BAD : inc_mode;
  if (OPT::foooo == 201){
    if (inc_mode != BAD){
      error(bDANGER, "%u: inc_mode was %d, changed to %d\n",
	    STATUS::iter[mode],  inc_mode, BAD);
    }
    inc_mode = BAD;
  }
  
  while (STATUS::iter[iSTEP] < itl){
    inc_mode = (inc_mode == BAD  ||  STATUS::iter[iSTEP] == OPT::itl[3])
      ? NO : OPT::incmode;
    if (trace >= tITERATION){
      print((double)-STATUS::iter[iSTEP]);
    }
    ++STATUS::iter[iPRINTSTEP];
    ++STATUS::iter[iSTEP];
    ++STATUS::iter[mode];
    ++STATUS::iter[iTOTAL];
    
    clear_arrays();
    STATUS::load.start();
    converged = CARD::dotr_all();
    STATUS::load.stop();
    if (converged  &&  STATUS::iter[iSTEP] > 1)
      break;
    ::solve();
    if (STATUS::iter[iSTEP] >= OPT::itl[8]){
      IO::suppresserrors = NO;
    }
    bypass_ok = OPT::bypass;
  }
  return converged;
}
/*--------------------------------------------------------------------------*/
static void advance_time(void)
{
  if (SIM::mode == sTRAN){
    static double last_iter_time;	
    if (SIM::time0 > last_iter_time){	/* moving forward */
      int ii;
      for (ii = 1;  ii <= STATUS::total_nodes;  ii++){
	ns.vt1[ii] = ns.v0[ii];
      }
    }else{				/* moving backward or DC */
      /* don't save voltages.  They're wrong !*/
    }
    last_iter_time = SIM::time0;
  }
}
/* last_iter_time is initially 0 by C definition.
 * On subsequent runs it will start with an arbitrary positive value.
 * SIM::time0 starts at either 0 or the ending time of the last run.
 * In either case, (time0 > last_iter_time) is false on the first step.
 * This correctly results in "don't save voltages..."
 */
/*--------------------------------------------------------------------------*/
static void clear_arrays(void)
{
  if (!SIM::inc_mode){			/* Clear working array */
    aa.zero();
    for (int ii = 1;  ii <= aa.size();  ii++){
      aa.d(ii,ii) = OPT::gmin;		/* gmin fudge */
      ns.i[ii] = 0.;			/* Clear new right side */
    }
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
