/* trvolts.c
 $Header: /al/acs/src/RCS/tr_volts.cc,v 8.1 95/04/23 18:20:40 al Exp $
 * dc and tr volts between two nodes (4 different versions)
 */
#include "ecah.h"
#include "e_node.h"
#include "e_card.h"
#include "u_option.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
	double	dc_volts(const node_t*,const node_t*);
	double	tr_volts(const node_t*,const node_t*);
	double	tr_volts_limited(const node_t*,const node_t*);
	double	tr_volts_t1(const node_t*,const node_t*);
//	double	logicval(const node_t*);
/*--------------------------------------------------------------------------*/
extern       struct nodestuff ns;
extern const struct nodestat *nstat;
/*--------------------------------------------------------------------------*/
/* dc_volts: dc voltage for bias calculations
 */
double dc_volts(const node_t *n1, const node_t *n2)
{
 return ns.vdc[n1->m]- ns.vdc[n2->m];
}
/*--------------------------------------------------------------------------*/
/* tr_volts: transient voltage, best approximation, no limiting
 */
double tr_volts(const node_t *n1, const node_t *n2)
{
 return ns.v0[n1->m] - ns.v0[n2->m];
}
/*--------------------------------------------------------------------------*/
/* tr_volts_limited: transient voltage, best approximation, with limiting
 */
double tr_volts_limited(const node_t *n1, const node_t *n2)
{
 double v1 = torange(OPT::vmin,ns.v0[n1->m],OPT::vmax);
 double v2 = torange(OPT::vmin,ns.v0[n2->m],OPT::vmax);
 double v = v1 - v2;
 double vo = torange(-OPT::limit, v, OPT::limit);
 if (OPT::foooo == 93){
    if (v1 != ns.v0[n1->m]) printf("v1=%g,%g\n", v1, ns.v0[n1->m]);
    if (v2 != ns.v0[n2->m]) printf("v2=%g,%g\n", v2, ns.v0[n2->m]);
    if (vo != v) printf("vo=%g,%g\n", vo, v);
 }
 return vo;
}
/*--------------------------------------------------------------------------*/
/* tr_volts_t1: transient voltage, 1 time ago
 */
double tr_volts_t1(const node_t *n1, const node_t *n2)
{
 return ns.vt1[n1->m]- ns.vt1[n2->m];
}
/*--------------------------------------------------------------------------*/
//double logicval(const node_t *n1)  /* cryptic interpretation of logic value */
//{
// struct nodestat s;
// s = nstat[n1->m];
// return (	 (2*s.lv0 + s.lv1)
//	+ (.1  * (OPT::transits - s.quality))
//	+ (.01 * (2 - s.nodemode)));
//}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
